--- old/usr/src/uts/common/fs/zfs/sa.c	2016-04-06 14:26:57.173670138 -0400
+++ new/usr/src/uts/common/fs/zfs/sa.c	2016-04-06 14:26:57.177895946 -0400
@@ -1380,6 +1380,7 @@
 		sa_handle_t *winner = NULL;
 
 		handle = kmem_cache_alloc(sa_cache, KM_SLEEP);
+		handle->sa_dbu.dbu_evict_func_prep = NULL;
 		handle->sa_dbu.dbu_evict_func = NULL;
 		handle->sa_userp = userp;
 		handle->sa_bonus = db;
@@ -1391,7 +1392,8 @@
 		error = sa_build_index(handle, SA_BONUS);
 
 		if (hdl_type == SA_HDL_SHARED) {
-			dmu_buf_init_user(&handle->sa_dbu, sa_evict, NULL);
+			dmu_buf_init_user(&handle->sa_dbu, NULL, sa_evict,
+			    NULL);
 			winner = dmu_buf_set_user_ie(db, &handle->sa_dbu);
 		}
 
